#ifndef BOOST_THREAD_PREAMBLE_HPP
#define BOOST_THREAD_PREAMBLE_HPP

//////////////////////////////////////////////////////////////////////////////
//
// (C) Copyright Vicente J. Botet Escriba 2008. Distributed under the Boost
// Software License, Version 1.0. (See accompanying file
// LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
//
// Based on the threadalert library of Roland Schwarz
//
//////////////////////////////////////////////////////////////////////////////
#include <boost/function.hpp>


namespace boost
{
  class thread_preamble {
  public:
 	template<typename Function>
	thread_preamble(Function inifn)
 		: initfunc_(inifn), prev_(last_) {
 		// the constructor is thread-safe because it is only used on
 		// global objects which are constructed before any threads
 		last_ = this;
 	  }
 	
    class proxy {
    public:
   	  template<typename Function>
   	  proxy(Function f): func_(f) {};
   	  proxy(const boost::function0<void>& f): func_(f) {};
      void operator()();
    private:
      const boost::function0<void> func_;
    };
  private:
    friend class proxy;
    static void func();
    const boost::function0<void> initfunc_;
    static thread_preamble* last_;
    thread_preamble* prev_;
  };

  
}

#endif

